/*
 *	Simplespeech.c
 *
 *	Version:	1.01
 *	Date:		24/3/86
 *
 *	A sample speech program written in Megamax C using Apple's MacinTalk
 *	speech driver.  I use the SimpleTools package for menus and DA handling.
 *	
 *	I use the strange kludge in chat.c because I found that I could not
 *	call speechon,then speechoff,then speechon again. I tried to, and got
 *	a "deep-shit" error and entered macsbug. Consequently, I kludged chat.c
 *	to keep my speech segment separate from the main program.
 *	
 *	I hope you don't mind the 'bad' code I write. My philosophy is :-
 *	"If it works, use it until it doesn't - then hack at it until it does..."
 *
 *	Help spread sources around the world.
 *
 *
 *	I hope you can get something out of it. It is "giftware".
 *
 *
 *	Jason Haines             ISD: +61 2 73-4444
 *	ElecEng Undergraduate    STD:  (02) 73-4444
 *	73 Davidson Avenue      ARPA: munnari!ipso!runx.oz!baron@SEISMO
 *	Concord NSW 2137        UUCP: seismo!munnari!basser!ipso!runx!baron
 *	AUSTRALIA                ACS: baron@runx
 *
 */

#include "stdio.h"
#include "speech.h"
#include <qd.h>
#include <qdvars.h>
#include <misc.h>
#include <event.h>
#include <pack.h>
#include <win.h>
#include <seg.h>
#include <res.h>
#include <chat.h>
#include <font.h>
#include <dialog.h>
#include <toolbox.h>

char *null[] = { 0 }; /* this is needed for use of execv */

/* SimpleTools Declarations */

#define itemdisable	0L
#define itemenable	1L
#define itemcheck	2L
#define itemuncheck	3L
extern char applestring[];
extern windowptr windowpoint();
extern int wprocid;
extern int dogoaway;
extern int windmenu;

/* End of SimpleTools Declarations */

/* MacinTalk Declarations */

speechhandle thespeech;
#define DEFPITCH	110
#define DEFRATE		140

/* End of MacinTalk Declarations */

/* Dialog Defs */
#define SAYITEM		1
#define CANCELITEM	2
#define OKITEM		2
#define OKITEM2		2
#define OKITEM3		1
#define MOREITEM	3
#define SAYTEXTITEM	3
#define GENTEXTITEM	2
/* End of Dialog Defs */

char str[256], infilename[256];
int c, err;
FILE *input_file,  *fopen();
int i = 0;
int voicemode, voicepitch, voicerate;
rect therect;
dialogptr	mydialogptr, aboutdialogptr, about2dialogptr, about3dialogptr,
			pitchdialogptr, ratedialogptr;
int itemtype,myitemhit;
handle itemhandle;
rect disprect;
char speechstr[256];

#define TRUE		1
#define FALSE		0
#define WXORIGIN1	50
#define WYORIGIN1	50
#define WIDTH1		400
#define HEIGHT1		250
#define WXORIGIN2	50
#define WYORIGIN2	50
#define WIDTH2		400
#define HEIGHT2		250

zerostr(string)
char string[];
{
	string[0] = '\0';
}


exit_to_other()
{
	transfer(null);
}


exit_to_shell()
{
	chat("",voicemode,voicepitch,voicerate,LAST_CALL);
	exittoshell();
}

nop()
{
}

set_pitch()
{
	int err, tmp;
	char answer[255];
	
	zerostr(answer);
	showwindow(pitchdialogptr);
	drawdialog(pitchdialogptr);
	do
	{
		modaldialog(NULL,&myitemhit);
	} while (myitemhit != OKITEM3);
	getditem(pitchdialogptr,GENTEXTITEM,&itemtype,&itemhandle,&disprect);
	getitext(itemhandle,&answer);
	setitext(itemhandle,"");
	tmp = atoi(answer);
	hidewindow(pitchdialogptr);
	if ((tmp < 69) || (tmp > 450))
	{
		paramtext("Pitch","69450","","");
		alert(708,NULL);
	}
	else
	{
		voicepitch = tmp;
		speechpitch(thespeech,voicepitch,(short)voicemode);
		menu("Speech","Reset to defaults^4",itemenable);
	}
}

set_rate()
{
	int err, tmp;
	char answer[255];
	
	zerostr(answer);
	showwindow(ratedialogptr);
	drawdialog(ratedialogptr);
	do
	{
		modaldialog(NULL,&myitemhit);
	} while (myitemhit != OKITEM3);
	getditem(ratedialogptr,GENTEXTITEM,&itemtype,&itemhandle,&disprect);
	getitext(itemhandle,&answer);
	setitext(itemhandle,"");
	hidewindow(ratedialogptr);
	tmp = atoi(answer);
	if ((tmp < 85) || (tmp > 425))
	{
		paramtext("Rate","85425","","");
		alert(708,NULL);
	}
	else
	{
		voicerate = tmp;
		speechrate(thespeech,voicerate);
		menu("Speech","Reset to defaults^4",itemenable);
	}
}

set_natural_mode()
{
	voicemode = natural;
	menu("Speech","Robotic Speech",itemuncheck);
	menu("Speech","Natural Speech",itemcheck);
	menu("Speech","Reset to defaults^4",itemenable);
}

set_robotic_mode()
{
	voicemode = robotic;
	menu("Speech","Robotic Speech",itemcheck);
	menu("Speech","Natural Speech",itemuncheck);
	menu("Speech","Reset to defaults^4",itemenable);
}

reset_settings()
{
	voicemode = natural;
	menu("Speech","Robotic Speech",itemuncheck);
	menu("Speech","Natural Speech",itemcheck);
	voicepitch = DEFPITCH;
	voicerate = DEFRATE;
	menu("Speech","Reset to defaults^4",itemdisable);
}

enter_speech()
{
	showwindow(mydialogptr);
	drawdialog(mydialogptr);
	chat("Go ahead, bash the keebord",voicemode,voicepitch,voicerate,NORMAL_CALL);
	do
	{
		modaldialog(NULL,&myitemhit);
		if (myitemhit == SAYITEM)
		{
			getditem(mydialogptr,SAYTEXTITEM,&itemtype,&itemhandle,&disprect);
			getitext(itemhandle,&speechstr);
			chat(speechstr,voicemode,voicepitch,voicerate,NORMAL_CALL);
		}
	} while (myitemhit != CANCELITEM);
	hidewindow(mydialogptr);
}


tell_about_me()
{
	int itemhit;
	
	showwindow(aboutdialogptr);
	drawdialog(aboutdialogptr);
	chat("Hello, I am Simple Speech, a sample speech program written in Cee using Apples Mackin Talk speech driver",voicemode,voicepitch,voicerate,NORMAL_CALL);
	chat("written by Jayson Haines, copy rite 9teen atee6.",voicemode,voicepitch,voicerate,NORMAL_CALL);
	chat("For more info, just hit the button.",voicemode,voicepitch,voicerate,NORMAL_CALL);
	do
	{
		modaldialog(NULL,&itemhit);
	} while ((itemhit != OKITEM) && (itemhit != MOREITEM));
	hidewindow(aboutdialogptr);
	if (itemhit == MOREITEM)
	{
		showwindow(about2dialogptr);
		drawdialog(about2dialogptr);
		chat("I am a giftware program, so you do not need to pay enee money to enn joy mee.",voicemode,voicepitch,voicerate,NORMAL_CALL);
		chat("If u like mee, keep mee. But, do not sell me..",voicemode,voicepitch,voicerate,NORMAL_CALL);
		do
		{
			modaldialog(NULL,&itemhit);
		} while (itemhit != OKITEM2);
		hidewindow(about2dialogptr);
	}
	showwindow(about3dialogptr);
	drawdialog(about3dialogptr);
	do
	{
		modaldialog(NULL,&itemhit);
	} while (itemhit != OKITEM3);
	hidewindow(about3dialogptr);
}


speak_file()
{
	char messagestr[256];
	
	if (!(err = getfile("TEXT",infilename)))
		return(0);
	if ((input_file = fopen (infilename, "r")) == NULL)
	{
		alert(1998,NULL);
		return(0);
	}
	/* SYNTAX: chat(string,mode,pitch,rateint,chatstat) */
	while ( (c = getc(input_file)) != EOF )
	{
		if (c=='\n')
		{
			str[i] = '\0';
			if (i>0)
				chat(str,voicemode,voicepitch,voicerate,NORMAL_CALL);
			i = 0;
		}
		else
			str[i++] = c;
	}
}

menusetup()
{
	menu (applestring,"About SimpleSpeech^1",tell_about_me);
	menu (applestring,"About SimpleSpeech^1",itemenable);
	menu("File","Open Speech File/O^2",speak_file);
	menu("File","Open Speech File/O^2",itemenable);
	menu("File","Transfer^7",exit_to_other);
	menu("File","(-",nop);
	menu("File","Quit/Q",exit_to_shell);
	menu("Edit","Undo",nop);
	menu("Edit","Undo",itemdisable);
	menu("Edit","Copy/C",nop);
	menu("Edit","Copy/C",itemdisable);
	menu("Edit","Cut/X",nop);
	menu("Edit","Cut/X",itemdisable);
	menu("Edit","Paste/V",nop);
	menu("Edit","Paste/V",itemdisable);
	menu("Edit","Clear",nop);
	menu("Edit","Clear",itemdisable);
	menu("Speech","Enter some words of wisdom^3",enter_speech);
	menu("Speech","Enter some words of wisdom^3",itemenable);
	menu("Speech","Set Pitch",set_pitch);
	menu("Speech","Set Pitch",itemenable);
	menu("Speech","Set Rate",set_rate);
	menu("Speech","Set Rate",itemenable);
	menu("Speech","Reset to defaults^4",reset_settings);
	menu("Speech","Reset to defaults^4",itemdisable);
	menu("Speech","Robotic Speech",set_robotic_mode);
	menu("Speech","Robotic Speech",itemuncheck);
	menu("Speech","Natural Speech",set_natural_mode);
	menu("Speech","Natural Speech",itemcheck);
}

windowsetup()
{
}


main()
{
	simpletools("About SimpleSpeech^1");
	menusetup();
	windowsetup();
	voicepitch = DEFPITCH;
	voicerate = DEFRATE;
	voicemode = natural;
	chat("",voicemode,voicepitch,voicerate,FIRST_CALL);
	mydialogptr = getnewdialog(21200,NULL,(windowptr) -1);
	aboutdialogptr = getnewdialog(21201,NULL,(windowptr) -1);
	about2dialogptr = getnewdialog(21202,NULL,(windowptr) -1);
	about3dialogptr = getnewdialog(18165,NULL,(windowptr) -1);
	ratedialogptr = getnewdialog(2300,NULL,(windowptr) -1);
	pitchdialogptr = getnewdialog(23620,NULL,(windowptr) -1);
	for (;;) simpleevents();
}
